clear all;
well_data = well_02;

N       = 400;
N_tr    = 400;

depth   = 2000;
x_bar   = 1 - depth/well_data.l;

ctrl_on_limit = 40;
obsv_on_limit = 40;

poles = [-0.15 + 0.02i, -0.15 - 0.02i];

tic;
hypSys = hypSys_from_well(N, N_tr, x_bar, ctrl_on_limit, obsv_on_limit, poles, well_data);
toc;

h = 0.1;
simHoriz = 200;
Tspan = 0:h:simHoriz;

ctrl_func = @controller_rec;

x0 = [  zeros(N, 1); zeros(N, 1); [10; 0]; ...
        zeros(N, 1); zeros(N, 1); [0; 0]; ...
        zeros(N_tr, 1)];

tic;
[t_log, x_log] = ode23(@(t,x) hypSys_w_obsv_odefun(t, x, ctrl_func, hypSys), Tspan, x0);
toc;

plotfile_w_observer;