clear all;

%% SPECIFIC FOR THIS SAMPLING
depth   = 1000;

%% PREWORK
load tfs_rec_d1000;

paramIndex = 3;
orderIndex = 2;

num = squeeze(num_vec(paramIndex, orderIndex, :))';
den = squeeze(den_vec(paramIndex, orderIndex, :))';

r_den = roots(den);
for k = 1:length(r_den)
    if (real(r_den(k)) > 0)
        r_den(k) = 0 + 1j * imag(r_den(k));
    end;
end;

den = poly(r_den);

num = num((length(num) - length(r_den) + 1):length(num));

[A_red, B_red, C_red, D_red] = tf2ss(num, den);

well_data = well_02;

N       = 400;
N_tr    = length(A_red);

x_bar   = 1 - depth/well_data.l;

ctrl_on_limit = 40;
obsv_on_limit = 40;

poles = [-0.15 + 0.02i, -0.15 - 0.02i];

tic;
hypSys = hypSys_from_well(N, N_tr, x_bar, ctrl_on_limit, obsv_on_limit, poles, well_data);
toc;

hypSys.A_red = A_red;
hypSys.B_red = B_red;
hypSys.C_red = C_red;
hypSys.D_red = D_red;

%% SET UP FOR SIMULATION
h = 0.1;
simHoriz = 200;
Tspan = 0:h:simHoriz;

N = hypSys.N;
N_tr = hypSys.N_tr;

x0 = [  zeros(N, 1); zeros(N, 1); [10; 0]; ...
        zeros(N, 1); zeros(N, 1); [0; 0]; ...
        zeros(N_tr, 1)];

%% SIMULATE
tic;
[t_log, x_log] = ode23(@(t,x) hypSys_w_redCtrl_odefun(t, x, hypSys), Tspan, x0);
toc;

plotfile_tf;