function Uin = controller_psf(t, u_aug, v_aug, z_aug, X, hypSys)

    ku = hypSys.ctrl_params.ku;
    kv = hypSys.ctrl_params.kv;
    
    K_rec_x_bar = hypSys.ctrl_params.K_rec_x_bar;
    K_psf_x_bar = hypSys.ctrl_params.K_psf_x_bar;
    
    x_bar = hypSys.x_bar;
    
    r = hypSys.r;
    q = hypSys.q;
    
    disp(t);
    
    if (x_bar > 0)
        Delta_grid = hypSys.Delta_grid;
        
        x_bar_index = 1 + ceil(x_bar/Delta_grid);
        
        L_a_xbar = hypSys.La(1:x_bar_index, x_bar_index);
        L_b_xbar = hypSys.Lb(1:x_bar_index, x_bar_index);
        
        V_integral = quadv(@(xi) ...
            (L_a_xbar(1 + ceil(xi/Delta_grid)) * delta(xi, u_aug, v_aug, hypSys) + ...
             L_b_xbar(1 + ceil(xi/Delta_grid)) * beta_from_u_and_v(1 - x_bar + xi, u_aug, v_aug, hypSys)), ...
             0, x_bar);
         
%         V_integral = 0;
  
        V = (1 / r) * delta(x_bar, u_aug, v_aug, hypSys) + (1 / r) * K_psf_x_bar * X + ...
                (1 / r) * V_integral;
    else
        V = (1/(r - q)) * K_rec_x_bar * X;
    end;
    
    Uin = ku*u_aug + kv * v_aug + V;