function Uin = controller_rec(t, u_aug, v_aug, z_aug, X, hypSys)

    ku = hypSys.ctrl_params.ku;
    kv = hypSys.ctrl_params.kv;
    
    K_rec_x_bar = hypSys.ctrl_params.K_rec_x_bar;
    
    x_bar = hypSys.x_bar;
    
    r = hypSys.r;
    q = hypSys.q;
    epsi = hypSys.epsi;
    
    disp(t);
    if (x_bar > 0)
        N_tr = hypSys.N_tr;
        Delta_tr = hypSys.Delta_tr;
        t_index = (0:(N_tr + 1))' .* Delta_tr;

        dv = 2 * hypSys.x_bar/hypSys.epsi;
        V_dv = interp1(t_index, z_aug, dv, 'linear');

        Delta_grid = hypSys.Delta_grid;

        x_bar_index = 1 + ceil(x_bar/Delta_grid);

        L_a_xbar = hypSys.La(1:x_bar_index, x_bar_index);
        L_b_xbar = hypSys.Lb(1:x_bar_index, x_bar_index);

        V_integral = quadv(@(xi) (q*L_a_xbar(1 + ceil(xi/Delta_grid)) * interp1(t_index, z_aug, (x_bar + xi)/epsi, 'linear') + ...
                                    L_b_xbar(1 + ceil(xi/Delta_grid)) * interp1(t_index, z_aug, (x_bar - xi)/epsi, 'linear')), 0, x_bar);

        V = (1 / r) * (q * V_dv + V_integral + K_rec_x_bar * X);
        
%         V = (q/r) * V_dv + (1/r) * Kr_x_bar * X;
    else
        V = (1/(r - q)) * K_rec_x_bar * X;
    end;
    
    Uin = ku*u_aug + kv * v_aug + V;