function alpha_val = alpha_from_u_and_v(y_val, u, v, hypSys)

    N = length(u);

    u_aug = [(2*u(1) - u(2)); ...
                u(1:N); ...
             (2*u(N) - u(N - 1))];
     
    v_aug = [(2*v(1) - v(2)); ...
                v(1:N); ...
             (2*v(N) - v(N - 1))];
    
    y_index = 1 + round(y_val*(length(u_aug) - 1));
    
    Kuu_y = hypSys.Kuu(:, y_index);
    Kuv_y = hypSys.Kuv(:, y_index);
    
    if (y_index == 1)
        alpha_val = u_aug(y_index);
    else
        Delta_grid = hypSys.Delta_grid;
               
        alpha_val = u_aug(y_index) - Delta_grid * [0.5*Kuu_y(1); ... 
                                                       Kuu_y(2:(y_index - 1)); ...
                                                   0.5*Kuu_y(y_index)]' * u_aug(1:y_index) - ...
                                     Delta_grid * [0.5*Kuv_y(1); ... 
                                                       Kuv_y(2:(y_index - 1)); ...
                                                   0.5*Kuv_y(y_index)]' * v_aug(1:y_index);
    end;