function beta_val = beta_from_u_and_v(y_val, u_aug, v_aug, hypSys)
    
    y_index = 1 + round(y_val*(length(u_aug) - 1));
    
    Kvu_y = hypSys.Kvu(:, y_index);
    Kvv_y = hypSys.Kvv(:, y_index);
    
    if (y_index == 1)
        beta_val = v_aug(y_index);
    else
        Delta_grid = hypSys.Delta_grid;
               
        beta_val =  v_aug(y_index) - Delta_grid * [0.5*Kvu_y(1); ... 
                                                       Kvu_y(2:(y_index - 1)); ...
                                                   0.5*Kvu_y(y_index)]' * u_aug(1:y_index) - ...
                                     Delta_grid * [0.5*Kvv_y(1); ... 
                                                       Kvv_y(2:(y_index - 1)); ...
                                                   0.5*Kvv_y(y_index)]' * v_aug(1:y_index);
    end;