function res = K_rec(hypSys)
    x_bar = hypSys.x_bar;
    epsi = hypSys.epsi;
    r = hypSys.r;
    A = hypSys.A;
    
    Delta_grid = hypSys.Delta_grid;

    x_bar_index = 1 + ceil(x_bar/Delta_grid);
    
    L_a_xbar = hypSys.La(1:x_bar_index, x_bar_index);
    L_b_xbar = hypSys.Lb(1:x_bar_index, x_bar_index);
    
    x_index = (0:(x_bar_index - 1)) * Delta_grid;
    

    if (x_bar > 0)
        integral_val = quadv(@(xi) (  interp1(x_index, L_a_xbar, xi, 'linear') * Psi_a(xi, hypSys) ...
                                    + interp1(x_index, L_b_xbar, xi, 'linear') * Psi_b(xi, hypSys)), ...
                                    0, x_bar);
    else
        integral_val = 0;
    end;
                            
    res = (Psi_a(x_bar, hypSys) - r * Psi_b(x_bar, hypSys) + integral_val) * expm(A * (1/epsi) * (1 - x_bar));