function ctrl = controller_gains(hypSys)
    N_grid = hypSys.N_grid;
    Delta_grid = hypSys.Delta_grid;
    
    Kvu = hypSys.Kvu;
    Kvv = hypSys.Kvv;
    
    Kvu1 = Kvu(:, N_grid)';
    Kvv1 = Kvv(:, N_grid)';
    
    ku = 0.5 * Delta_grid * [Kvu1(1) 2*Kvu1(2:(N_grid-1)) Kvu1(N_grid)]; % Trapezoidal rule
    kv = 0.5 * Delta_grid * [Kvv1(1) 2*Kvv1(2:(N_grid-1)) Kvv1(N_grid)]; % Trapezoidal rule
    
    K_rec_x_bar = K_rec(hypSys);
    K_psf_x_bar = K_psf(hypSys);
    K_inf_x_bar = K_inf(K_rec_x_bar, hypSys);
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% Store values
    ctrl.ku = ku;
    ctrl.kv = kv;
    ctrl.K_rec_x_bar = K_rec_x_bar;
    ctrl.K_psf_x_bar = K_psf_x_bar;
    ctrl.K_inf_x_bar = K_inf_x_bar;