function res = observer_gains(poles, hypSys)
    epsi = hypSys.epsi;
    A = hypSys.A;
    C = hypSys.C;
    Puu = hypSys.Puu;
    Pvu = hypSys.Pvu;
    
    N_grid = hypSys.N_grid;
    Delta_grid = hypSys.Delta_grid;
    
    xspan = 0:Delta_grid:1;
    L = place(A',C',poles)';
    
    CexpAphixL = zeros(N_grid, 1);

    for k = 1:N_grid
        CexpAphixL(k) = C * expm(A * (1 - xspan(k)) / epsi) * L;
    end

    p11 = zeros(N_grid, 1);
    p22 = zeros(N_grid, 1);
    
    for k = 1:N_grid
        integrand = Delta_grid * Puu(k:N_grid, k)' * CexpAphixL(k:N_grid);
        p11(k) = CexpAphixL(k) - epsi * Puu(N_grid, k) ...
                - sum(integrand) + 0.5 * Delta_grid * (integrand(1) + integrand(end));
            
            
        integrand = Delta_grid * Pvu(k:N_grid, k)' * CexpAphixL(k:N_grid);
        p22(k) = - epsi * Pvu(N_grid, k) ...
                - sum(integrand) + 0.5 * Delta_grid * (integrand(1) + integrand(end));
    end;
    
    
%     for k = 1:N_grid
%         p11(k) = CexpAphixL(k) - epsi * Puu(N_grid, k) + ...
%              0.5*Puu(k, k)*CexpAphixL(k) + ...
%                  Puu((k+1):(N_grid-1), k)'*CexpAphixL((k+1):(N_grid-1)) + ...
%              0.5*Puu(N_grid, k)*CexpAphixL(N_grid);
%          
%    
%         p22(k) = - epsi * Pvu(N_grid, k) + ...
%              0.5*Pvu(k, k)*CexpAphixL(k) + ...
%                  Pvu((k+1):(N_grid-1), k)'*CexpAphixL((k+1):(N_grid-1)) + ...
%              0.5*Pvu(N_grid, k)*CexpAphixL(N_grid);
%     end;

    p1 = p11;
    p2 = p22;
%     for k = 0:(N_grid - 1)
%         p1(k + 1) = C * expm(A * (1 - Delta_grid * k) / epsi) * L - ...
%                         epsi * Puu(N_grid, k + 1) - ...
%                         quadv(@(xi) interp1(0:Delta_grid:1, Puu(:, k + 1), xi) * C * expm(A * (1 - xi) / epsi) * L, k * Delta_grid, 1);
%                     
%         p2(k + 1) = 0 - epsi * Pvu(N_grid, k + 1) - ...
%                         quadv(@(xi) interp1(0:Delta_grid:1, Pvu(:, k + 1), xi) * C * expm(A * (1 - xi) / epsi) * L, k * Delta_grid, 1);
%     end;
%     
%     disp(p1 - p11);
%     disp(p2 - p22);
%     
    pX = expm(A / epsi) * L;
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% Store values
    res.p1 = p1;
    res.p2 = p2;
    res.pX = pX;
    
    res.L  = L;