function q_spec = Laguerre_spectrum(numFreqs, alpha_LG, gamma_LG, dataVec)

    n_aug = (-numFreqs:(numFreqs-1))';
    theta_aug = (n_aug + 0.5) * pi / numFreqs;

    dataVec_aug = [flipud(conj(dataVec)); dataVec];

    dummy = dataVec_aug.*(sqrt(gamma_LG)./(1 - exp(1j*theta_aug)));
    dummy2 = exp(-1j*n_aug*pi/(2*numFreqs)).*fftshift(fft(fftshift(dummy)))/(2*numFreqs);
    q_spec = real(dummy2((numFreqs+1):(2*numFreqs)));  