function find_params(depth, gammadiff_vec, sampling_fun, type, data_filename)
    %% CONFIG
    numFreqs = 100;

    %% SET UP
    alpha_LG_vec = zeros(length(gammadiff_vec), 1);
    gamma_LG_vec = zeros(length(gammadiff_vec), 1);


    hypSys = setup_hypSys(depth);
    gamma_func = @(alpha_LG, gammadiff)(gammadiff + 2 * alpha_LG);

    amin = 0.001;
    amax = 1;

    for i = 1:length(gammadiff_vec)
        gammadiff = gammadiff_vec(i);

        %% FIND OPTIMAL PARAMETERS
        opt_alpha = fminbnd(@error_fun, amin, amax, [], numFreqs, gamma_func, gammadiff, sampling_fun, hypSys);

        alpha_LG_vec(i) = opt_alpha;
        gamma_LG_vec(i) = gamma_func(opt_alpha, gammadiff);
    end;


    %% STORE RESULTS
    save(data_filename, 'alpha_LG_vec', 'gamma_LG_vec', 'depth', 'type');