function [num, den] = gen_tf(sampling_fun, numFreqs, alpha_LG, gamma_LG, order, hypSys)

    s_vec = Laguerre_sampling_points(numFreqs, alpha_LG, gamma_LG);
    dataVec = sampling_fun(s_vec, hypSys);

    %% FIND THE LAGUERRE SPECTRUM
    q_spec = Laguerre_spectrum(numFreqs, alpha_LG, gamma_LG, dataVec);

    %% FIND RATIONAL APPROXIMATION
    [num, den] = Laguerre_Gram(q_spec, numFreqs, alpha_LG, gamma_LG, order);