function gen_tf_from_file(orders, param_filename, tf_filename)

    load(param_filename, 'alpha_LG_vec', 'gamma_LG_vec', 'depth', 'type');
    
    %% CONFIG
    numFreqs = 100;
    
    if (strcmp(type, 'rec'))
        sampling_fun = @h_YU_rec_sampling;
    else
        if (strcmp(type, 'psf'))
            sampling_fun = @h_YU_psf_sampling;
        else
            sampling_fun = @h_YU_inf_sampling;
        end;
    end;
    
    numOfOrder = length(orders);
    maxOrder = max(orders);
    
    numerOfParamSets = length(alpha_LG_vec);
    num_vec = zeros(numerOfParamSets, numOfOrder, maxOrder);
    den_vec = zeros(numerOfParamSets, numOfOrder, maxOrder + 1);
    
    hypSys = setup_hypSys(depth);
    
    for i = 1:numerOfParamSets
        for j = 1:numOfOrder
            [num, den] = gen_tf(sampling_fun, numFreqs, alpha_LG_vec(i), gamma_LG_vec(i), orders(j), hypSys);

            num_aug = [zeros(1, maxOrder - orders(j)) num];
            den_aug = [zeros(1, maxOrder - orders(j)) den];
            num_vec(i, j, :) = num_aug';
            den_vec(i, j, :) = den_aug';
        end;
    end;


    %% STORE RESULTS
    save(tf_filename, 'num_vec', 'den_vec', 'alpha_LG_vec', 'gamma_LG_vec', 'depth', 'type');