function plot_approxes(tf_filename, correct_neg_eigs, unwrap_phase)

    load(tf_filename, 'num_vec', 'den_vec', 'alpha_LG_vec', 'gamma_LG_vec', 'depth', 'type');

    %% CONFIG
    if (strcmp(type, 'rec'))
        sampling_fun = @h_YU_rec_sampling;
    else
        if (strcmp(type, 'psf'))
            sampling_fun = @h_YU_psf_sampling;
        else
            sampling_fun = @h_YU_inf_sampling;
        end;
    end;

    numFreqs = 100;

    omega = logspace(-2, 1, numFreqs);
    s_vec = 1j * omega;

    %% SET UP
    hypSys = setup_hypSys(depth);

    dataVec = sampling_fun(s_vec, hypSys);
    
    [numerOfParamSets, numOfOrder, maxOrder] = size(num_vec);
    
    for i = 1:numerOfParamSets
        for j = 1:numOfOrder
            num = squeeze(num_vec(i, j, :))';
            den = squeeze(den_vec(i, j, :))';
            
            gain0 = 1 / den(end);
            
            if (correct_neg_eigs == 1)
                r_den = roots(den);
                for k = 1:length(r_den)
                    if (real(r_den(k)) > 0)
                        r_den(k) = 0 + 1j * imag(r_den(k));
                    end;
                end;

                den = poly(r_den);
            end;
            
            gain1 = 1 / den(end);
            
            num = num .* (gain0 / gain1);
            
            sigma = 0.5 * gamma_LG_vec(i) - alpha_LG_vec(i);
            order = sum(num ~= 0);
            plotfile_tf_bode_and_zplane;
        end;
    end;
