figBx = 640;
figBy = 512;
figBigBx = figBx*2;
figBigBy = figBy*2;

figNarrowBy = 400;

%% Figure 1: u_tilde, v_tilde (3D plots)
figure;
set(gcf, 'Color', [1 1 1], 'Units', 'pixels', 'Position', [0,0,figBx,figBigBy]);

    L_width = 1;

    Hr = polyval(num, 1j * omega) ./ polyval(den, 1j * omega);
    [Hr_mag, Hr_phase] = bode(tf(num, den), omega);
    Hr_mag = squeeze(Hr_mag);
    if (unwrap_phase == 1)
        Hr_phase = squeeze(Hr_phase);
    else
        Hr_phase = unwrap(angle(Hr)) * 180 / pi;
    end;
    
    subplot(3, 1, 1);
    
    semilogx(omega, 20 * log10(abs(dataVec)), 'k', 'LineWidth', L_width);
    hold on;
    semilogx(omega, 20 * log10(Hr_mag), 'r--', 'LineWidth', L_width);
    hold off;
    grid on;
    
    title(['Bode plot \sigma = ' num2str(sigma) ', order = ' num2str(order)]);
    xlabel('Frequency [rad / sec]');
    ylabel('Magnitude [dB]');
    
    legend('Original', 'Approximation', 'Location', 'Best'); 
    
    subplot(3, 1, 2);
    if (unwrap_phase == 1)
        unwrapped_phase_H_deg = unwrap(phase(dataVec)) * 180 / pi;
    else
        unwrapped_phase_H_deg = angle(dataVec) * 180 / pi;
    end;
    semilogx(omega, unwrapped_phase_H_deg - unwrapped_phase_H_deg(1) + Hr_phase(1), 'k', 'LineWidth', L_width);
    hold on;
    semilogx(omega, Hr_phase, 'r--', 'LineWidth', L_width);
    hold off;
    grid on;
    
    xlabel('Frequency [rad / sec]');
    ylabel('Phase [deg]');
    
    legend('Original', 'Approximation', 'Location', 'Best'); 

subplot(3, 1, 3);

% set(gcf, 'Color', [1 1 1], 'Units', 'pixels', 'Position', [figBx,0,figBx,figBy]);
zplane(roots(num), roots(den));


% legend_str_zplane{1} = 'Zeros';
% legend_str_zplane{2} = 'Poles';
% 
% columnlegend(2, legend_str_zplane, 'Location', 'SouthWest', 'Fontsize', 12);